package com.twelvemonkeys.imageio.plugins.ico;

import com.twelvemonkeys.imageio.util.ImageReaderAbstractTestCase;

import java.util.Arrays;
import java.util.List;
import java.awt.*;
import javax.imageio.spi.ImageReaderSpi;

/**
 * CURImageReaderTestCase
 *
 * @author <a href="mailto:harald.kuhr@gmail.com">Harald Kuhr</a>
 * @author last modified by $Author: haraldk$
 * @version $Id: CURImageReaderTestCase.java,v 1.0 Apr 1, 2008 10:39:17 PM haraldk Exp$
 */
public class CURImageReaderTestCase extends ImageReaderAbstractTestCase<ICOImageReader> {
    protected List<TestData> getTestData() {
        return Arrays.asList(
                new TestData(getClassLoaderResource("/cur/hand.cur"), new Dimension(32, 32)),
                new TestData(getClassLoaderResource("/cur/zoom.cur"), new Dimension(32, 32))
        );
    }

    protected ImageReaderSpi createProvider() {
        return new CURImageReaderSpi();
    }

    @Override
    protected ICOImageReader createReader() {
        return new ICOImageReader(ICO.TYPE_CUR);
    }

    protected Class<ICOImageReader> getReaderClass() {
        return ICOImageReader.class;
    }

    protected List<String> getFormatNames() {
        return Arrays.asList("cur");
    }

    protected List<String> getSuffixes() {
        return Arrays.asList("cur");
    }

    protected List<String> getMIMETypes() {
        return Arrays.asList("image/vnd.microsoft.cursor", "image/cursor", "image/x-cursor");
    }
}